package com.yy.platform.baseservice.profile;

import android.content.Context;
import android.util.Log;

import com.yy.platform.baseservice.YYServiceCore;

public class DefaultServiceProfileFactory implements ServiceProfileFactory {

    private static Context mAppContext;
    public static String sDefLogDir = "/yyservicesdk/";

    public DefaultServiceProfileFactory(Context ctx) {
        mAppContext = ctx;
    }

    public static final class DefaultLogger implements LogProfile.ILog {

        private boolean mEnableLog = true;

        public DefaultLogger() {
            mEnableLog = true;
        }

        public DefaultLogger(boolean enable) {
            mEnableLog = enable;
        }

        @Override
        public void outputLog(String log) {
            if (mEnableLog) {
                Log.i(YYServiceCore.TAG, log);
            }
        }
    }

    /**
     * 默认日志配置
     */
    public static class DefaultLogProfile implements LogProfile {

        @Override
        public ILog getLog() {
            return null;
        }

        @Override
        public String logPath() {
            return null;
        }

        @Override
        public boolean isLogCat() {
            return false;
        }
    }

    @Override
    public LogProfile logProfile() {
        return new DefaultLogProfile();
    }

    @Override
    public ChannelProfile channelProfile() {
        return null;
    }
}
