package com.yy.platform.baseservice.statis;

import java.security.NoSuchAlgorithmException;

public class TextUtils {

    // 用来将字节转换成 16 进制表示的字符
    private static final char[] hexDigits = {
            '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

    public static String bytes2hex(byte[] data) {
        char[] str = new char[data.length * 2];
        int k = 0;
        for (int i = 0; i < data.length; i++) {
            byte byte0 = data[i];
            str[k++] = hexDigits[byte0 >>> 4 & 0xf]; // 取字节中高 4 位的数字转换,
            str[k++] = hexDigits[byte0 & 0xf]; // 取字节中低 4 位的数字转换
        }
        return new String(str);
    }

    public static String length2DecimalChar(int length) {
        //String.format()在国外某些语言系统格式化数字会出现阿拉伯语
        String lenStr = format8length(length);
        return lenStr;
    }

    private static String format8length(int len) {
        StringBuffer sb = new StringBuffer(8);
        int r = 8 - (len + "").length();
        while (r-- > 0) {
            sb.append(0);
        }
        sb.append(len);
        return sb.toString();
    }

    private static final ThreadLocal<java.security.MessageDigest> MD5_DIGEST
            = new ThreadLocal<java.security.MessageDigest>() {
        @Override
        protected java.security.MessageDigest initialValue() {
            try {
                return java.security.MessageDigest.getInstance("MD5");
            } catch (NoSuchAlgorithmException e) {
                throw new RuntimeException(e);
            }
        }
    };

    public static byte[] md5byte(byte[] source) {
        java.security.MessageDigest md = MD5_DIGEST.get();
        md.reset();
        md.update(source);
        // MD5 的计算结果是一个 128 位的长整数
        byte[] tmp = md.digest();
        return tmp;
    }

}
