#define SAMPLES 5

uniform mat4 uMVPMatrix;  // MVP 的变换矩阵（整体变形）
uniform mat4 uTexMatrix;  // Texture 的变换矩阵 （只对texture变形）

uniform float uTexelWidthOffset;
uniform float uTexelHeightOffset;

attribute vec4 aPosition;
attribute vec4 aTextureCoord;

varying vec2 vTextureCoord;
varying vec2 vBlurTextureCoord[SAMPLES];


void main() {
    gl_Position = uMVPMatrix * aPosition;
    vTextureCoord = (uTexMatrix * aTextureCoord).xy;

    vBlurTextureCoord[0] = vec2(vTextureCoord.x, vTextureCoord.y - uTexelHeightOffset * 5.0);
    vBlurTextureCoord[1] = vec2(vTextureCoord.x - uTexelWidthOffset * 5.0, vTextureCoord.y);
    vBlurTextureCoord[2] = vTextureCoord;
    vBlurTextureCoord[3] = vec2(vTextureCoord.x + uTexelWidthOffset * 5.0, vTextureCoord.y);
    vBlurTextureCoord[4] = vec2(vTextureCoord.x, vTextureCoord.y + uTexelHeightOffset * 5.0);
}